package dev.shadowsoffire.apotheosis.adventure.boss;

import com.mojang.serialization.Codec;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.placebo.codec.CodecProvider;
import com.google.gson.JsonElement;
import net.minecraft.resources.ResourceLocation;
import java.util.Map;
import net.minecraft.util.profiling.ProfilerFiller;
import net.minecraft.server.packs.resources.ResourceManager;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;

public class BossRegistry extends WeightedDynamicRegistry<ApothBoss>
{
    public static final BossRegistry INSTANCE;
    
    public BossRegistry() {
        super(AdventureModule.LOGGER, "bosses", false, false);
    }
    
    protected Map<ResourceLocation, JsonElement> m_5944_(final ResourceManager pResourceManager, final ProfilerFiller pProfiler) {
        final Map<ResourceLocation, JsonElement> map = super.m_5944_(pResourceManager, pProfiler);
        map.keySet().removeIf(r -> "brutalbosses".equals(r.m_135827_()));
        return map;
    }
    
    protected void validateItem(final ResourceLocation key, final ApothBoss item) {
        super.validateItem(key, (CodecProvider)item);
        item.validate(key);
    }
    
    protected void registerBuiltinCodecs() {
        this.registerDefaultCodec(Apotheosis.loc("boss"), (Codec)ApothBoss.CODEC);
    }
    
    static {
        INSTANCE = new BossRegistry();
    }
}
